Index: trunk/src/win32k/kKrnlLib/src/Extract.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 9084)
+++ trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 9085)
@@ -1,3 +1,3 @@
-# $Id: Extract.mak,v 1.8 2002-08-20 05:47:53 bird Exp $
+# $Id: Extract.mak,v 1.9 2002-08-22 02:55:48 bird Exp $
 
 #
@@ -10,26 +10,20 @@
 
 #
-# Load the build setup.
+# Setup config
 #
 !include ..\..\makefile.inc
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
-PATH_BIN   = $(PATH_TOOLS)
-
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 
 #
-# Config.
+# Target config
 #
-TARGET_NAME = Extract
-MAKEFILE    = $(TARGET_NAME).mak
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DEXTRACT -DLOGGING_DISABLED
-TARGET_STACKSIZE = 0x2000
-
-
-#
-# Object files.
-#
-PREMAKEFILES = Extract16.mak
+TARGET_NAME     = Extract
+TARGET_PUBNAME  = $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
+TARGET_STACKSIZE= 0x2000
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DEXTRACT -DLOGGING_DISABLED
+MAKEFILE        = $(TARGET_NAME).mak
+PREMAKEFILES    = Extract16.mak
 
 TARGET_OBJS =\
@@ -53,7 +47,6 @@
 $(LIB_OS)\
 
-
 #
-# Load the build process rules.
+# Rules config
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/Extract16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 9084)
+++ trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 9085)
@@ -1,3 +1,3 @@
-# $Id: Extract16.mak,v 1.7 2002-08-20 05:47:53 bird Exp $
+# $Id: Extract16.mak,v 1.8 2002-08-22 02:55:48 bird Exp $
 
 #
@@ -10,7 +10,6 @@
 #
 
-
 #
-# Setup.
+# Setup config
 #
 !if [SET INCLUDE=]
@@ -18,22 +17,16 @@
 BUILD_ENV_FORCE = MSCV6-16
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 !include ..\..\makefile.inc
 
+#
+# Target config
+#
+TARGET_MODE     = LIB
+TARGET_NAME     = Extract16
+MAKEFILE        = $(TARGET_NAME).mak
+ALL_INCLUDES    = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
+ALL_DEFINES     = -DEXTRACT
 
-
-#
-# Config.
-#
-TARGET_MODE = LIB
-TARGET_NAME = Extract16
-MAKEFILE    = $(TARGET_NAME).mak
-ALL_INCLUDES= -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
-ALL_DEFINES = -DEXTRACT
-
-
-#
-# Targets.
-#
 TARGET_OBJS =\
 $(PATH_TARGET)\Extract.$(EXT_OBJ)\
@@ -44,7 +37,6 @@
 $(PATH_TARGET)\krnlImportTable.$(EXT_OBJ)\
 
-
 #
-# Process.
+# Rules config
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/MkCallTab.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 9084)
+++ trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 9085)
@@ -1,3 +1,3 @@
-# $Id: MkCallTab.mak,v 1.9 2002-08-20 07:04:34 bird Exp $
+# $Id: MkCallTab.mak,v 1.10 2002-08-22 02:57:24 bird Exp $
 
 #
@@ -9,7 +9,6 @@
 #
 
-
 #
-# Setup.
+# Setup config
 #
 !if [SET INCLUDE=]
@@ -17,23 +16,17 @@
 BUILD_ENV_FORCE = MSCV6-16
 PATH_ROOT  = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 !include ..\..\makefile.inc
-PATH_BIN   = $(PATH_TOOLS)
-
-
 
 #
-# Config.
+# Target config
 #
-TARGET_MODE = EXE
-TARGET_NAME = MkCallTab
-MAKEFILE    = $(TARGET_NAME).mak
-CC_INCLUDES = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
-ALL_DEFINES = -DMKCALLTAB
+TARGET_NAME     = MkCallTab
+TARGET_NEEDED   = 1
+TARGET_PUBNAME  = $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
+MAKEFILE        = $(TARGET_NAME).mak
+CC_INCLUDES     = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
+ALL_DEFINES     = -DMKCALLTAB
 
-
-#
-# Targets.
-#
 TARGET_OBJS =\
 $(PATH_TARGET)\MkCallTab.$(EXT_OBJ)\
@@ -48,24 +41,11 @@
 $(PATH_MSC)\lib\$(LIB_C_OBJ)\
 
-
 #
-# Rules to automatically forward.
+# Rule config
 #
-RULES_FORWARD = calltaba.asm kKrnlLib.def TstFakers.c tst
-
-
-#
-# Process.
-#
+RULES_FORWARD = calltaba.asm ..\kKrnlLibImpLib.$(EXT_DEF) TstFakers.c tst
 !include $(MAKE_INCLUDE_PROCESS)
 
-
 !if !$(BUILD_FORWARDING)
-#
-# Install duplicate...
-#
-$(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT): $(TARGET)
-    $(TOOL_COPY) $(TARGET) $(PATH_BIN)
-
 
 #
@@ -74,15 +54,15 @@
 
 # kKrnlLib Import library definition file.
-kKrnlLib.def: $(PATH_TARGET)\kKrnlLibImpLib.def
-..\kKrnlLibImpLib.def:      $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
-    $(PATH_TOOLS)\MkCallTab.exe deffile > $@
+..\kKrnlLibimplib.$(EXT_DEF): $(TARGET_PUBNAME)
+    $(TARGET_PUBNAME) deffile > $@
 
 # Generate calltaba.asm
-calltaba.asm:               $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
-    $(PATH_TOOLS)\MkCallTab.exe calltab > $@
+calltaba.asm:           $(TARGET_PUBNAME)
+    $(TARGET_PUBNAME) calltab > $@
 
 # Generate TstFakers.c
-TstFakers.c:                $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
-    $(PATH_TOOLS)\MkCallTab.exe tstfakers > $@
+TstFakers.c:            $(TARGET_PUBNAME)
+    $(TARGET_PUBNAME) tstfakers > $@
 
 !endif # !BUILD_FORWARDING
+