Index: trunk/src/win32k/kKrnlLib/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/Makefile	(revision 9085)
+++ trunk/src/win32k/kKrnlLib/Makefile	(revision 9086)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.32 2002-08-20 05:49:14 bird Exp $
+# $Id: Makefile,v 1.33 2002-08-22 03:07:50 bird Exp $
 
 #
@@ -23,13 +23,21 @@
 BUILD_OWN_TESTCASE_RULE = 1
 !ifdef WITH_KLIB
-SUBDIRS     = kLib\src tools
+SUBDIRS     = kLib\src
 !endif
+
 PREMAKEFILES=\
+!ifdef WITH_KKRNLLIB
+        kKrnlLib.mak \
+#        kKrnlLibR3Tst.mak \
+!endif
 !ifdef WITH_KLIB
         kLibR3.mak \
 !endif
+
 !ifdef WITH_KKRNLLIB
-        kKrnlLib.mak kKrnlLibR3Tst.mak
+SUBDIRS_NEEDED = tools
 !endif
+SUBDIRS_TESTCASE =
+
 
 
Index: trunk/src/win32k/kKrnlLib/kKrnlLib.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/kKrnlLib.mak	(revision 9085)
+++ trunk/src/win32k/kKrnlLib/kKrnlLib.mak	(revision 9086)
@@ -1,3 +1,3 @@
-# $Id: kKrnlLib.mak,v 1.5 2002-08-20 05:49:14 bird Exp $
+# $Id: kKrnlLib.mak,v 1.6 2002-08-22 03:07:50 bird Exp $
 
 #
@@ -9,9 +9,8 @@
 
 #
-# Setup.
+# Setup config.
 #
 PATH_ROOT = ..\..\..
 !include $(PATH_ROOT)\make\setup.mak
-
 
 #
@@ -21,21 +20,18 @@
 !endif
 
+#
+# Target config.
+#
+TARGET_MODE     = SYS
+TARGET_NAME     = kKrnlLib
+TARGET_ILIB_YES = 1
+TARGET_IDEF     = $(TARGET_NAME)implib.$(EXT_DEF)
+ALL_INCLUDES    = -I../kLib/include -I../include
+ALL_DEFINES     = -DKKRNLLIB
+MAKEFILE        = $(TARGET_NAME).mak
+SUBDIRS         = src kLib\src
+#SUBDIRS_DEP    = $(SUBDIRS) include
+PREMAKEFILES    = clib16.mak devhelp16.mak
 
-#
-# Config.
-#
-TARGET_MODE = SYS
-TARGET_NAME = kKrnlLib
-TARGET_ILIB = kKrnlLib.lib
-TARGET_IDEF = kKrnlLibimplib.def
-MAKEFILE    = $(TARGET_NAME).mak
-C_INCLUDES  = -I../include/kLib -I../include
-AS_INCLUDES = -I../include/kLib -I../include
-AS_DEFINES  = -DKKRNLLIB
-
-
-#
-# Object files.
-#
 TARGET_OBJS =\
 $(PATH_OBJ)\kKrnlLib_first.$(EXT_LIB)\kKrnlLib_first.$(EXT_LIB)\
@@ -66,28 +62,20 @@
 $(PATH_OBJ)\kKrnlLib_last.$(EXT_LIB)\kKrnlLib_last.$(EXT_LIB)
 
-SUBDIRS     = include src kLib\src
-PREMAKEFILES= clib16.mak devhelp16.mak
-
-
-
 #
-# Process
+# Rule config.
 #
+RULES_FORWARD = $(TARGET).$(EXT_ILIB) $(TARGET_IDEF) $(TARGET_ILIB)
 !include $(MAKE_INCLUDE_PROCESS)
 
-
-#
-# kKrnlLib Import library.
-#
-$(TARGET).lib: $(PATH_LIB)\$(TARGET).lib
-$(PATH_LIB)\$(TARGET).lib: $(PATH_TOOLS)\MkCallTab.exe
-    $(PATH_TOOLS)\MkCallTab.exe deffile > $(PATH_TARGET)\$(TARGET)implib.def
-    $(IMPLIB) $(IMPLIB_FLAGS) $@ $(PATH_TARGET)\$(TARGET)implib.def
-
+!if !$(BUILD_FORWARDING)
 
 #
 # Generate import definition file.
 #
-$(TARGET_IDEF): .force
-    $(TOOL_DODIRS) "src" $(TOOL_MAKE) -f MkCallTab.mak ..\$(TARGET_IDEF)
+$(TARGET_IDEF): $(PATH_TOOLS)\MkCallTab.$(EXT_EXE)
+    $** deffile > $@
 
+# alias for generating the import library.
+$(TARGET_NAME).$(EXT_ILIB): $(TARGET_ILIB)
+
+!endif #!BUILD_FORWARDING
Index: trunk/src/win32k/kKrnlLib/src/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Makefile	(revision 9085)
+++ trunk/src/win32k/kKrnlLib/src/Makefile	(revision 9086)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.9 2002-08-20 05:47:53 bird Exp $
+# $Id: Makefile,v 1.10 2002-08-22 03:07:06 bird Exp $
 
 #
@@ -10,12 +10,11 @@
 
 #
-# Load the build setup.
+# Setup config
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
-
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 
 #
-# Config.
+# Target config
 #
 TARGET_MODE  = SYSLIB
@@ -24,11 +23,14 @@
 ALL_DEFINES  = -DKKRNLLIB
 
+PREMAKEFILES =\
+    MkCallTab.mak \
+    newdbg.mak \
+    newrel.mak \
+    Dev16.mak \
 
-#
-# Targets.
-#
-PREMAKEFILES = MkCallTab.mak newdbg.mak newrel.mak Dev16.mak
-
-POSTMAKEFILES = first.mak last.mak srcR3Tst.mak
+POSTMAKEFILES =\
+    first.mak \
+    last.mak \
+#    srcR3Tst.mak \
 
 TARGET_OBJS =\
@@ -64,22 +66,21 @@
 $(PATH_TARGET)\calltaba.$(EXT_OBJ)\
 
-
-TARGET_DEPS =\
-$(PATH_OBJ)\kKrnlLib_newdbg.$(EXT_LIB)\kKrnlLib_newdbg.$(EXT_LIB)\
-$(PATH_OBJ)\kKrnlLib_newrel.$(EXT_LIB)\kKrnlLib_newrel.$(EXT_LIB)\
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\kKrnlLib_dev16.$(EXT_LIB)\kKrnlLib_dev16.$(EXT_LIB)\
-
 TARGET_NO_DEP=\
 calltaba.c
 
+#
+# Rules config
+#
+RULES_FORWARD = calltaba.asm
+!include $(MAKE_INCLUDE_PROCESS)
+
+!if !$(BUILD_FORWARDING)
 
 #
-# Load the build process rules.
+# Generate calltaba.asm.
 #
-!include $(MAKE_INCLUDE_PROCESS)
+calltaba.asm: $(PATH_TOOLS)\MkCallTab.$(EXT_EXE)
+    $** calltab > $@
 
+!endif #!BUILD_FORWARDING
 
-# generated code.
-calltaba.asm: .force
-    $(TOOL_DOMAKES) "MkCallTab.mak" $(TOOL_MAKE) $@
-
Index: trunk/src/win32k/kKrnlLib/tools/ignore.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/tools/ignore.mak	(revision 9085)
+++ trunk/src/win32k/kKrnlLib/tools/ignore.mak	(revision 9086)
@@ -1,3 +1,3 @@
-# $Id: ignore.mak,v 1.3 2002-08-22 02:09:44 bird Exp $
+# $Id: ignore.mak,v 1.4 2002-08-22 03:07:50 bird Exp $
 
 #
@@ -12,5 +12,5 @@
 #
 PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 
 #