Index: trunk/src/win32k/kKrnlLib/src/Dev16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Dev16.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/Dev16.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: Dev16.mak,v 1.8 2002-08-22 03:19:27 bird Exp $
+# $Id: Dev16.mak,v 1.9 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -9,32 +9,27 @@
 #
 
-
 #
-# Setup.
+# Setup config.
 #
 !if [SET INCLUDE=]
 !endif
+PATH_ROOT       = ..\..\..\..
 BUILD_ENV_FORCE = MSCV6-16
 ALL_SEG_TEXT    = CODE16
 ALL_SEG_DATA    = DATA16
-PATH_ROOT       = ..\..\..\..
+ALL_DEFINES     = -DKKRNLLIB
+CC_INCLUDES     = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
 !include $(PATH_ROOT)\make\setup.mak
-!include ..\..\makefile.inc
-
+#!include ..\..\makefile.inc
 
 #
-# Config.
+# Target config
 #
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_dev16
-MAKEFILE    = Dev16.mak
-CC_INCLUDES = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
-ALL_DEFINES = -DKKRNLLIB
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = dev16
+TARGET_SUB      = kKrnlLib
+MAKEFILE        = $(TARGET_NAME).mak
 
-
-#
-# Targets.
-#
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\d16Strat.$(EXT_OBJ)\
 $(PATH_TARGET)\d16Init.$(EXT_OBJ)\
@@ -45,7 +40,6 @@
 $(PATH_TARGET)\krnlImportTable.$(EXT_OBJ)\
 
-
 #
-# Process.
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/Dev16R3Tst.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: Dev16R3Tst.mak,v 1.7 2002-08-22 03:19:27 bird Exp $
+# $Id: Dev16R3Tst.mak,v 1.8 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -11,5 +11,5 @@
 
 #
-# Setup.
+# Setup config.
 #
 !if [SET INCLUDE=]
@@ -18,4 +18,6 @@
 ALL_SEG_TEXT    = CODE16
 ALL_SEG_DATA    = DATA16
+CC_INCLUDES     = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
+ALL_DEFINES     = -DKKRNLLIB -DR3TST
 PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
@@ -24,17 +26,12 @@
 
 #
-# Config.
+# Target config.
 #
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_Dev16R3Tst
-MAKEFILE    = Dev16R3Tst.mak
-CC_INCLUDES = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
-ALL_DEFINES = -DKKRNLLIB -DR3TST
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = Dev16
+TARGET_SUB      = kKrnlLib\R3Tst
+MAKEFILE        = Dev16R3Tst.mak
 
-
-#
-# Targets.
-#
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\d16Globl.$(EXT_OBJ)\
 $(PATH_TARGET)\d16Init.$(EXT_OBJ)\
@@ -45,7 +42,6 @@
 $(PATH_TARGET)\krnlImportTable.$(EXT_OBJ)\
 
-
 #
-# Process.
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/Extract.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/Extract.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: Extract.mak,v 1.9 2002-08-22 02:55:48 bird Exp $
+# $Id: Extract.mak,v 1.10 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -12,7 +12,10 @@
 # Setup config
 #
+#!include ..\..\makefile.inc
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DEXTRACT -DLOGGING_DISABLED
+PATH_ROOT       = ..\..\..\..
+!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 !include ..\..\makefile.inc
-PATH_ROOT = ..\..\..\..
-!include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 
 #
@@ -20,30 +23,20 @@
 #
 TARGET_NAME     = Extract
-TARGET_PUBNAME  = $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
+TARGET_MODE     = EXE
+TARGET_PUB_DIR  = $(PATH_TOOLS)
 TARGET_STACKSIZE= 0x2000
-ALL_INCLUDES    = -I../include -I../kLib/include
-ALL_DEFINES     = -DEXTRACT -DLOGGING_DISABLED
 MAKEFILE        = $(TARGET_NAME).mak
-PREMAKEFILES    = Extract16.mak
+PREMAKEFILES_LIB= Extract16.mak
 
 TARGET_OBJS =\
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\Extract16.$(EXT_LIB)\Extract.$(EXT_OBJ)\
+$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\Extract16.$(EXT_LIB)\Extract16.$(EXT_LIB)\
 $(PATH_TARGET)\Extract32.$(EXT_OBJ)\
 $(PATH_TARGET)\krnlPrologs.$(EXT_OBJ)\
 
 TARGET_LIBS =\
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\Extract16.$(EXT_LIB)\Extract16.$(EXT_LIB)\
-$(PATH_TOOLKIT)\lib\os2286.lib\
-$(PATH_MSC)\lib\clibcep.lib\
-!if "$(BUILD_ENV)" == "VAC308"
-cppon30.$(EXT_LIB)\
-!else
-!if "$(BUILD_ENV)" == "VAC365"
-cpprni36.$(EXT_LIB)\
-!else
-$(LIB_C_OBJ)\
-!endif
-!endif
+$(PATH_TOOLKIT)\lib\os2286.$(EXT_LIB)\
+$(PATH_MSC)\lib\clibcep.$(EXT_LIB)\
 $(LIB_OS)\
+$(LIB_C_NRE)\
 
 #
Index: trunk/src/win32k/kKrnlLib/src/Extract16.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/Extract16.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: Extract16.mak,v 1.8 2002-08-22 02:55:48 bird Exp $
+# $Id: Extract16.mak,v 1.9 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -16,7 +16,8 @@
 !endif
 BUILD_ENV_FORCE = MSCV6-16
-PATH_ROOT  = ..\..\..\..
+ALL_INCLUDES    = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
+ALL_DEFINES     = -DEXTRACT
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
-!include ..\..\makefile.inc
 
 #
@@ -26,8 +27,6 @@
 TARGET_NAME     = Extract16
 MAKEFILE        = $(TARGET_NAME).mak
-ALL_INCLUDES    = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
-ALL_DEFINES     = -DEXTRACT
 
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\Extract.$(EXT_OBJ)\
 $(PATH_TARGET)\d16Globl.$(EXT_OBJ)\
Index: trunk/src/win32k/kKrnlLib/src/Makefile
===================================================================
--- trunk/src/win32k/kKrnlLib/src/Makefile	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/Makefile	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: Makefile,v 1.10 2002-08-22 03:07:06 bird Exp $
+# $Id: Makefile,v 1.11 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -12,5 +12,7 @@
 # Setup config
 #
-PATH_ROOT = ..\..\..\..
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
 
@@ -18,21 +20,22 @@
 # Target config
 #
-TARGET_MODE  = SYSLIB
-TARGET_NAME  = kKrnlLib_src
-ALL_INCLUDES = -I../include -I../kLib/include
-ALL_DEFINES  = -DKKRNLLIB
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = src
+TARGET_SUB      = kKrnlLib
 
-PREMAKEFILES =\
-    MkCallTab.mak \
+PREMAKEFILES_NEEDED =\
+    MkCallTab.mak\
+
+PREMAKEFILES_LIB    =\
     newdbg.mak \
     newrel.mak \
     Dev16.mak \
 
-POSTMAKEFILES =\
+POSTMAKEFILES_LIB =\
     first.mak \
     last.mak \
 #    srcR3Tst.mak \
 
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\d32Globals.$(EXT_OBJ)\
 $(PATH_TARGET)\d32Hlp.$(EXT_OBJ)\
@@ -58,19 +61,20 @@
 $(PATH_TARGET)\vprintf.$(EXT_OBJ)\
 $(PATH_TARGET)\vsprintf.$(EXT_OBJ)\
-$(PATH_OBJ)\kKrnlLib_newdbg.$(EXT_LIB)\kKrnlLib_newdbg.$(EXT_LIB)\
-$(PATH_OBJ)\kKrnlLib_newrel.$(EXT_LIB)\kKrnlLib_newrel.$(EXT_LIB)\
+$(PATH_OBJ)\$(TARGET_SUB)\newdbg.$(EXT_LIB)\newdbg.$(EXT_LIB)\
+$(PATH_OBJ)\$(TARGET_SUB)\newrel.$(EXT_LIB)\newrel.$(EXT_LIB)\
 \
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\kKrnlLib_dev16.$(EXT_LIB)\kKrnlLib_dev16.$(EXT_LIB)\
+$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\$(TARGET_SUB)\dev16.$(EXT_LIB)\dev16.$(EXT_LIB)\
 \
 $(PATH_TARGET)\SymDB32.$(EXT_OBJ)\
 $(PATH_TARGET)\calltaba.$(EXT_OBJ)\
 
-TARGET_NO_DEP=\
-calltaba.c
+TARGET_NO_DEP   =\
+calltaba.c \
+calltaba.asm
 
 #
 # Rules config
 #
-RULES_FORWARD = calltaba.asm
+RULES_FORWARD   = calltaba.asm
 !include $(MAKE_INCLUDE_PROCESS)
 
Index: trunk/src/win32k/kKrnlLib/src/MkCallTab.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/MkCallTab.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: MkCallTab.mak,v 1.10 2002-08-22 02:57:24 bird Exp $
+# $Id: MkCallTab.mak,v 1.11 2002-08-24 22:07:40 bird Exp $
 
 #
@@ -12,10 +12,9 @@
 # Setup config
 #
-!if [SET INCLUDE=]
-!endif
+#!if [SET INCLUDE=]
+#!endif
 BUILD_ENV_FORCE = MSCV6-16
-PATH_ROOT  = ..\..\..\..
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\$(BUILD_SETUP_MAK)
-!include ..\..\makefile.inc
 
 #
@@ -23,11 +22,12 @@
 #
 TARGET_NAME     = MkCallTab
+TARGET_MODE     = EXE
 TARGET_NEEDED   = 1
-TARGET_PUBNAME  = $(PATH_TOOLS)\$(TARGET_NAME).$(TARGET_EXT)
+TARGET_PUB_DIR  = $(PATH_TOOLS)
 MAKEFILE        = $(TARGET_NAME).mak
 CC_INCLUDES     = -I../include -I../kLib/include -I$(PATH_DDKBASE)/h -I$(PATH_MSC)/include -I$(PATH_TOOLKIT)/h
 ALL_DEFINES     = -DMKCALLTAB
 
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\MkCallTab.$(EXT_OBJ)\
 $(PATH_TARGET)\krnlImportTable.$(EXT_OBJ)\
@@ -37,12 +37,12 @@
 $(PATH_TARGET)\d16vprintf.$(EXT_OBJ)\
 
-TARGET_LIBS =\
-$(PATH_TOOLKIT)\lib\$(LIB_OS)\
-$(PATH_MSC)\lib\$(LIB_C_OBJ)\
+TARGET_LIBS     =\
+$(LIB_OS) \
+$(LIB_C_OBJ) \
 
 #
 # Rule config
 #
-RULES_FORWARD = calltaba.asm ..\kKrnlLibImpLib.$(EXT_DEF) TstFakers.c tst
+RULES_FORWARD = calltaba.asm ..\kKrnlLibImpLib.$(EXT_DEF) TstFakers.c
 !include $(MAKE_INCLUDE_PROCESS)
 
Index: trunk/src/win32k/kKrnlLib/src/first.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/first.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/first.mak	(revision 9124)
@@ -1,6 +1,6 @@
-# $Id: first.mak,v 1.5 2002-08-20 05:04:42 bird Exp $
+# $Id: first.mak,v 1.6 2002-08-24 22:07:41 bird Exp $
 
 #
-# kKrnlLib_first.lib makefile.
+# devFirst.lib makefile.
 #
 # Copyright (c) 1998-2002 knut st. osmundsen (bird@anduin.net)
@@ -10,29 +10,21 @@
 
 #
-# Load the build setup.
+# Setup config.
 #
-PATH_ROOT = ..\..\..\..
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
 
+#
+# Target config.
+#
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = devFirst
+TARGET_SUB      = kKrnlLib
+MAKEFILE        = first.mak
 
 #
-# Config.
-#
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_first
-MAKEFILE    = first.mak
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB
-
-
-#
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\devFirst.$(EXT_OBJ)\
-
-
-#
-# Load the build process rules.
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/last.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/last.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/last.mak	(revision 9124)
@@ -1,6 +1,6 @@
-# $Id: last.mak,v 1.5 2002-08-20 05:04:43 bird Exp $
+# $Id: last.mak,v 1.6 2002-08-24 22:07:41 bird Exp $
 
 #
-# kKrnlLib_last.lib makefile.
+# devLast.lib makefile.
 #
 # Copyright (c) 1998-2002 knut st. osmundsen (bird@anduin.net)
@@ -10,30 +10,21 @@
 
 #
-# Load the build setup.
+# Setup config.
 #
-PATH_ROOT = ..\..\..\..
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
 
+#
+# target config.
+#
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = devLast
+TARGET_SUB      = kKrnlLib
+MAKEFILE        = last.mak
 
 #
-# Config.
-#
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_last
-MAKEFILE    = last.mak
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB
-
-
-#
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\devLast.$(EXT_OBJ)\
-
-
-
-#
-# Load the build process rules.
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/newdbg.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newdbg.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/newdbg.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: newdbg.mak,v 1.5 2002-08-20 05:04:43 bird Exp $
+# $Id: newdbg.mak,v 1.6 2002-08-24 22:07:41 bird Exp $
 
 #
@@ -9,34 +9,26 @@
 #
 
-
 #
-# Setup.
+# Setup config.
 #
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
-ALL_DBGMEM = 1
+ALL_DBGMEM      = 1
 !endif
-PATH_ROOT   = ..\..\..\..
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
 
 
 #
-# Config.
+# Target config.
 #
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_newdbg
-MAKEFILE    = newdbg.mak
-
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = newdbg
+TARGET_SUB      = kKrnlLib
+MAKEFILE        = newdbg.mak
 
 #
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\newdbg.$(EXT_OBJ)
-
-
-#
-# Process
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/newdbgR3Tst.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: newdbgR3Tst.mak,v 1.4 2002-08-20 05:04:43 bird Exp $
+# $Id: newdbgR3Tst.mak,v 1.5 2002-08-24 22:07:41 bird Exp $
 
 #
@@ -9,34 +9,26 @@
 #
 
-
 #
-# Setup.
+# Setup config.
 #
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB -DR3TST
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB -DR3TST
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
-ALL_DBGMEM = 1
+ALL_DBGMEM      = 1
 !endif
-PATH_ROOT   = ..\..\..\..
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
 
 
 #
-# Config.
+# Target config.
 #
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_newdbgR3Tst
-MAKEFILE    = newdbgR3Tst.mak
-
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = newdbg
+TARGET_SUB      = kKrnlLib\R3Tst
+MAKEFILE        = newdbgR3Tst.mak
 
 #
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\newdbg.$(EXT_OBJ)
-
-
-#
-# Process
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/newrel.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newrel.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/newrel.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: newrel.mak,v 1.5 2002-08-20 05:04:43 bird Exp $
+# $Id: newrel.mak,v 1.6 2002-08-24 22:07:41 bird Exp $
 
 #
@@ -9,33 +9,25 @@
 #
 
+#
+# Setup config.
+#
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB
+!if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
+ALL_NO_DBGMEM   = 1
+!endif
+PATH_ROOT       = ..\..\..\..
+!include $(PATH_ROOT)\make\setup.mak
 
 #
-# Setup.
+# Target config.
 #
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB
-!if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
-ALL_NO_DBGMEM = 1
-!endif
-PATH_ROOT   = ..\..\..\..
-!include $(PATH_ROOT)\make\setup.mak
-
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = newrel
+TARGET_SUB      = kKrnlLib
+MAKEFILE        = $(TARGET_NAME).mak
 
 #
-# Config.
-#
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_newrel
-MAKEFILE    = newrel.mak
-
-#
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\newrel.$(EXT_OBJ)
-
-
-#
-# Process
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/newrelR3Tst.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: newrelR3Tst.mak,v 1.4 2002-08-20 05:04:43 bird Exp $
+# $Id: newrelR3Tst.mak,v 1.5 2002-08-24 22:07:41 bird Exp $
 
 #
@@ -9,34 +9,26 @@
 #
 
-
 #
-# Setup.
+# Setup config.
 #
-ALL_INCLUDES= -I../include -I../kLib/include
-ALL_DEFINES = -DKKRNLLIB -DR3TST
+ALL_INCLUDES    = -I../include -I../kLib/include
+ALL_DEFINES     = -DKKRNLLIB -DR3TST
 !if "$(BUILD_ENV)" == "VAC308" || "$(BUILD_ENV)" == "VAC365"
-ALL_NO_DBGMEM = 1
+ALL_NO_DBGMEM   = 1
 !endif
-PATH_ROOT   = ..\..\..\..
+PATH_ROOT       = ..\..\..\..
 !include $(PATH_ROOT)\make\setup.mak
 
 
 #
-# Config.
+# Target config.
 #
-TARGET_MODE = SYSLIB
-TARGET_NAME = kKrnlLib_newrelR3Tst
-MAKEFILE    = newrelR3Tst.mak
-
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = newrel
+TARGET_SUB      = kKrnlLib\R3Tst
+MAKEFILE        = newrelR3Tst.mak
 
 #
-# Object files.
-#
-TARGET_OBJS =\
-$(PATH_TARGET)\newrel.$(EXT_OBJ)
-
-
-#
-# Process
+# Rules config.
 #
 !include $(MAKE_INCLUDE_PROCESS)
Index: trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak
===================================================================
--- trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak	(revision 9107)
+++ trunk/src/win32k/kKrnlLib/src/srcR3Tst.mak	(revision 9124)
@@ -1,3 +1,3 @@
-# $Id: srcR3Tst.mak,v 1.6 2002-08-20 05:47:53 bird Exp $
+# $Id: srcR3Tst.mak,v 1.7 2002-08-24 22:07:42 bird Exp $
 
 #
@@ -10,28 +10,24 @@
 
 #
-# Load the build setup.
+# Setup config.
 #
-PATH_ROOT = ..\..\..\..
+PATH_ROOT       = ..\..\..\..
+ALL_INCLUDES    = -I../include -I../kLib/include
+AS_INCLUDES     = -I$(PATH_DDKBASE)\inc
+ALL_DEFINES     = -DKKRNLLIB -DR3TST
 !include $(PATH_ROOT)\make\setup.mak
 !include ..\..\makefile.inc
 
+#
+# Target config.
+#
+TARGET_MODE     = SYSLIB
+TARGET_NAME     = src
+TARGET_SUB      = kKrnlLib\R3Tst
+MAKEFILE        = srcR3Tst.mak
 
-#
-# Config.
-#
-TARGET_MODE  = SYSLIB
-TARGET_NAME  = kKrnlLib_srcR3Tst
-MAKEFILE     = srcR3Tst.mak
-ALL_INCLUDES = -I../include -I../kLib/include
-AS_INCLUDES  = -I$(PATH_DDKBASE)\inc
-ALL_DEFINES  = -DKKRNLLIB -DR3TST
+PREMAKEFILES    = newdbgR3Tst.mak newrelR3Tst.mak Dev16R3Tst.mak
 
-
-#
-# Targets.
-#
-PREMAKEFILES = newdbgR3Tst.mak newrelR3Tst.mak Dev16R3Tst.mak
-
-TARGET_OBJS =\
+TARGET_OBJS     =\
 $(PATH_TARGET)\d32Globals.$(EXT_OBJ)\
 $(PATH_TARGET)\d32Hlp.$(EXT_OBJ)\
@@ -66,8 +62,8 @@
 $(PATH_TARGET)\tstkKrnlLib.$(EXT_OBJ)\
 \
-$(PATH_OBJ)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\
-$(PATH_OBJ)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\
+$(PATH_OBJ)\$(TARGET_SUB)\newdbg.$(EXT_LIB)\newdbg.$(EXT_LIB)\
+$(PATH_OBJ)\$(TARGET_SUB)\newrel.$(EXT_LIB)\newrel.$(EXT_LIB)\
 \
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\kKrnlLib_dev16R3Tst.$(EXT_LIB)\kKrnlLib_dev16R3Tst.$(EXT_LIB)\
+$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\$(TARGET_SUB)\dev16.$(EXT_LIB)\dev16.$(EXT_LIB)\
 \
 $(PATH_TARGET)\SymDB32.$(EXT_OBJ)\
@@ -75,24 +71,28 @@
 $(PATH_TARGET)\TstFakers.$(EXT_OBJ)\
 
-
-TARGET_DEPS =\
-$(PATH_OBJ)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\kKrnlLib_newdbgR3Tst.$(EXT_LIB)\
-$(PATH_OBJ)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\kKrnlLib_newrelR3Tst.$(EXT_LIB)\
-$(PATH_ROOT)\obj\$(SHT_TRGPLTFRM)$(SHT_BLDMD)mscv6-16\kKrnlLib_dev16.$(EXT_LIB)\kKrnlLib_dev16.$(EXT_LIB)\
-
-
-TARGET_NO_DEP=\
-calltaba.c\
-TstFakers.c
-
+TARGET_NO_DEP   =\
+TstFakers.c \
+calltaba.asm \
 
 #
-# Load the build process rules.
+# Rules config.
 #
+RULES_FORWARD   = calltaba.asm TstFakers.c
 !include $(MAKE_INCLUDE_PROCESS)
 
+!if !$(BUILD_FORWARDING)
 
-# generated code.
-TstFakers.c: .force
-    $(TOOL_DOMAKES) "MkCallTab.mak" $(TOOL_MAKE) $@
+#
+# Generate calltaba.asm.
+#
+calltaba.asm: $(PATH_TOOLS)\MkCallTab.$(EXT_EXE)
+    $** calltab > $@
 
+#
+# Generate TstFakers.asm.
+#
+TstFakers.c: $(PATH_TOOLS)\MkCallTab.$(EXT_EXE)
+    $** tstfakers > $@
+
+!endif #!BUILD_FORWARDING
+